<template>
  <CCol md="5">
    <CCard>
      <CCardBody>
        <CForm>
          <h1>
            Lオク ログイン
          </h1>
          <CInput
            v-model="email"
            placeholder="ログイン ID"
          >
            <template #prepend-content>
              <font-awesome-icon :icon="['fas', 'user-tie']" class="width-1x" />
            </template>
          </CInput>
          <CInput
            v-model="password"
            placeholder="パスワード"
            type="password"
          >
            <template #prepend-content>
              <font-awesome-icon :icon="['fas', 'lock']" class="width-1x" />
            </template>
          </CInput>
          <CInput
            type="hidden"
            :invalid-feedback="message"
            :is-valid="!message"
          />
          <CRow>
            <CCol col="6">
              <CButton color="primary" class="px-4" @click="login">
                ログイン
              </CButton>
            </CCol>
            <CCol col="6" class="text-right">
              <!-- <CButton color="link" class="px-0">
                Forgot password?
              </CButton> -->
            </CCol>
          </CRow>
        </CForm>
      </CCardBody>
    </CCard>
  </CCol>
</template>

<script>
import { get } from 'lodash'

export default {
  layout: 'blank',

  data () {
    return {
      email: '',
      password: '',
      message: ''
    }
  },

  methods: {
    /**
     * login function
     */
    async login () {
      try {
        const resLogin = await this.$dam.login({
          email: this.email,
          password: this.password
        })

        const data = resLogin.data
        if (!get(data, 'api_token', false)) {
          this.message = 'Reponse invalid, plse check server api.'
          return
        }

        this.$dam.setAuthToken(data.api_token)
        this.$router.push('/')
      } catch (err) {
        console.error(err)

        this.message = get(err, 'response.data.message', '')
      }
    }
  }
}
</script>
